this.name		 	= "System Features: DS Corona";
this.author			= "rustem"; 
this.copyright		= "March 2016";
this.licence		= "CC-BY-SA 4.0";
this.version		= "0.4";
this.description	= "Populator script for the sun features";

"use strict";

//Based on System_Features_Sunspots
//develop -cim-, edit -rustem-

this.startUp = function() {
		this.$overrides = [[],[],[],[],[],[],[],[]];
		delete this.startUp;
		this.logging = true; // Must be false for release
		if(this.logging) log(this.name,'startUp - System Features for DistantStars');
		//if did not saved in the system with solar activity and need jump(timer) for reset and recalculate.
		this.$overrides[galaxyNumber] = system.ID.toString();
		if(this.logging && system.info.description.indexOf("solar activity") > -1) {
			if(this.logging) log(this.name,'The startup system with solar activity and need jump for recalculate');
		}		
}

this._clearFeatures = function() {
		//for clearing overrides
		//this.setFeatures = false;
		this.$overrides = [[],[],[],[],[],[],[],[]]; // not timer memory of the unpredictable solar activity, may be add TODO list.
		System.infoForSystem(galaxyNumber, system.ID).corona_flare = null; // for oolite v1.84
		//System.infoForSystem(galaxyNumber, system.ID).corona_flare = 0;  // for oolite v1.80
		if(this.logging) log(this.name,'Reset solar activity');
		return;
}

this.systemWillPopulate = function() {
	system.setPopulator("system_features_sun",
						{
							callback: this._addFeatures.bind(this),
							priority: 1000
						});
}

this._addFeatures = function() {
		if (this.$overrides[galaxyNumber].indexOf(system.ID) > -1) {
				this.setFeatures = true;
				if(this.logging) log(this.name,'The overrides corona flare is: '+system.info.corona_flare); // Not setup of sun features
				return;
		} 
		if (!system.sun) {
				return;
		}

		// make the solar flare

		this.setFeatures = false;

		var addflare = 0;
		var rndflare = Math.random()*10;
		var muxflare = Math.random()*1;
		var corflare = system.info.corona_flare;
		if(this.logging) log(this.name,'Default corona flare is: '+corflare); //.toFixed(3)
		 
		// for oolite v1.84 - Added small random value to corona flare for all type of stars - 0.5%.
		corflare += Math.random()*0.005;
								
		if (system.info.description.indexOf("solar activity") > -1) {
				if (system.info.sun_name.indexOf("Star") > -1 ) { // checking a type of star
						if (system.info.sun_name.indexOf("A2") > -1 ) {
							corflare += Math.random()*0.040;
							if(this.logging) log(this.name,'Set A2 corona flare is : '+corflare);
						}
						if (system.info.sun_name.indexOf("A7") > -1 ) {
							corflare += Math.random()*0.025;
							if(this.logging) log(this.name,'Set A7 corona flare is : '+corflare);
						}
						if (system.info.sun_name.indexOf("F2") > -1 ) {
							corflare += Math.random()*0.017;
							if(this.logging) log(this.name,'Set F2 corona flare is : '+corflare);
						}
						if (system.info.sun_name.indexOf("G2") > -1 ) {
							corflare += Math.random()*0.013;
							if(this.logging) log(this.name,'Set G2 corona flare is : '+corflare);
						}
						if (system.info.sun_name.indexOf("K2") > -1 ) {
							corflare += Math.random()*0.011;
							if(this.logging) log(this.name,'Set K2 corona flare is : '+corflare);
						}
						if (system.info.sun_name.indexOf("K8") > -1 ) {
							corflare += Math.random()*0.010;
							if(this.logging) log(this.name,'Set K8 corona flare is : '+corflare);
						}
				} else log(this.name,'Error: No correct star name!');			
				addflare += corflare*0.5;
				rndflare *= 1.5;
				if (system.info.description.indexOf("frequent solar activity") > -1) { // checking a type of activity
						//rndflare += 3;
						addflare += 0.025;
						if(this.logging) log(this.name,'Add frequent value : '+addflare);
				} else if (system.info.description.indexOf("dreadful solar activity") > -1 || system.info.description.indexOf("deadly solar activity") > -1) {
						//rndflare *= 1.5;
						addflare += 0.15;
						if(this.logging) log(this.name,'Add dreadful(ly) value : '+addflare);
				} else if (system.info.description.indexOf("unpredictable solar activity") > -1 ) {
						//rndflare += 1.5;
						rndflare = Math.floor(rndflare-4.5);
						if (rndflare < 1) rndflare = 0;
						rndflare *= muxflare*0.015;
						addflare += rndflare;
						if(this.logging) log(this.name,'Add unpredictable value: '+addflare);
				}
				corflare += addflare;				
		}
		
		this.setFeatures = true;
		System.infoForSystem(galaxyNumber, system.ID).corona_flare = corflare;	
		if(this.logging) log(this.name,'Finally corona flare is: '+corflare); //.toFixed(3)	
		/*
		//Set to distant star value for oolite v1.80
		if (corflare === 0) {
				if (system.info.sun_name.indexOf("Star") > -1 ) {
						if (system.info.sun_name.indexOf("A2") > -1 ) {
							corflare = 0.24 + Math.random()*0.08;
							if(this.logging) log(this.name,'Set A2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("A7") > -1 ) {
							corflare = 0.12 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set A7 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("F2") > -1 ) {
							corflare = 0.08 + Math.random()*0.06;
							if(this.logging) log(this.name,'Set F2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("G2") > -1 ) {
							corflare = 0.06 + Math.random()*0.04;
							if(this.logging) log(this.name,'Set G2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K2") > -1 ) {
							corflare = 0.05 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K2 corona flare is:'+corflare);
						}
						if (system.info.sun_name.indexOf("K8") > -1 ) {
							corflare = 0.03 + Math.random()*0.03;
							if(this.logging) log(this.name,'Set K8 corona flare is:'+corflare);
						}
				} else if(this.logging) log(this.name,'No star name!');
				System.infoForSystem(galaxyNumber, system.ID).corona_flare = corflare;
				if(this.logging) log(this.name,'Set to distant star value. Final corona flare is:'+corflare);
		}
		*/
}

this.shipWillEnterWitchspace = function(cause)
{
	this._resetFeatures();
}

this._resetFeatures = function()
{
	if (this.setFeatures) this._clearFeatures();
	return;
}
